using System;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace TemplateMod.Items
{
	//The ExampleX Classes are not meant to be used as their primary function, they are merely hook listings.
    public class ExampleItem : ModItem
    {
        public ExampleItem(ModBase modBase, Item I) : base(modBase, I){ }

		public override void Effects(Player player) { }
		public override void ArmorSetBonus(Player player) { } //called when a full armor set is worn.
		public override void VanitySetBonus(Player player) { } //called when a full armor set is visually worn.

		public override void OnCraft(Recipe recipe) { }
		public override string OnAffixName(string currentName, string oldName) { return currentName; }

		public override bool? UseItem(Player P) { return null;  }
		public override void UseItemEffects(Player P, Rectangle rect) { }
		public override bool CanUse(Player P) { return true; }
		public override bool ConsumeItem(Player p) { return true; } //called when a consumable is about to be consumed.
		public override bool ConsumeAmmo(Player p) { return true; } //called when ammo is about to be consumed. (called both on gun and ammo)

		//these 5 methods used to be in custom UseStyle and HoldStyles, but are now per item.
		public override void UseStyle(Player p) { }
		public override void HoldStyle(Player p) { }
		public override void SetUseFrame(Player p) { }
		public override bool SetHoldFrame(Player p) { return false; }
		public override Rectangle SetUseHitbox(Player p, Rectangle rect) { return rect; }

		public override bool PreShoot(Player player, Vector2 position, Vector2 velocity, int type, int damage, float knockback) { return true; }

		//Called when an NPC damages this item's player.
		public override void DamagePlayer(NPC npc, Player owner, int hitDir, ref int damage, ref bool crit, ref float critMult) { }
		public override void DealtPlayer(NPC npc, Player owner, int hitDir, int dmgDealt, bool crit) { }

		//Called when this item's player attacks another player.
		public override void DamagePVP(Player owner, Player p, int hitDir, ref int damage, ref bool crit, ref float critMult) { }
		public override void DealtPVP(Player owner, Player p, int hitDir, int dmgDealt, bool crit) { }

		//called when this item's player damages an NPC.
		public override void DamageNPC(Player owner, NPC npc, int hitDir, ref int damage, ref bool crit, ref float critMult) { }
		public override void DealtNPC(Player owner, NPC npc, int hitDir, int dmgDealt, bool crit) { }

		public override bool? CanHitPlayer(NPC npc, Player owner) { return null; }
		public override bool? CanHitPVP(Player owner, Player p) { return null; }
		public override bool? CanHitNPC(Player owner, NPC npc) { return null; }
    }
}
