using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace TemplateMod
{
    public class MBase : TAPI.ModBase //MBase can be any name
    {
        public override void OnLoad(){ } //Called when the mod is first loaded. 
        public override void OnUnload(){ } //Called when the mod is unloaded.
		public override void OnAllModsLoaded() //Called when all mods are loaded.
		{
			//an example biome
			Biome B = new Biome("ExampleBiome", new List<int> { TileDef.type["TemplateMod:ExampleTile"] }, new List<int> { }, 50);
			B.SetBiomeMusic(Biome.MusicPriority.High, "vanilla:Music_22"); //ocean music
			B.AddToGame();		
		}
		public override void PreGameDraw(SpriteBatch sb) { } //Called before all game drawing.
        public override void PostGameDraw(SpriteBatch sb) { } //Called after all game drawing is finished.

        public override void ChooseTrack(ref string current) { } //Called when the music track updates.

		public override void OptionChanged(Option option) { } // Called when leaving the options page on all options for this mod with notify (ie recently changed)
		public override List<string> OptionList(Option option) // Called on Dynamic options for this mod to fill possibleValues.
		{
			if (option.name == "codedValue")
			{
				List<string> list = new List<string>();
				list.AddRange(new string[] { "Derp", "> 9000", "much choice", "I don't even", "NOPE" });
				return list;
			}
			return null;
		} 

        public override object OnModCall(TAPI.ModBase mod, params object[] args) { return base.OnModCall(mod, args);  } //Called when another mod calls this on your mod. (used for inter-mod communicating)
        public override void NetReceive(int msgType, BinBuffer bb) { } //Used to handle networking.
    }
}