using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace TemplateMod.NPCs
{
    public class ExampleMobNPC : ModNPC
    {
        public ExampleMobNPC(ModBase modBase, NPC n) : base(modBase, n){ }

		public override void HitEffect(int hitDirection, double damage, bool isDead)
		{
			for (int m = 0; m < (isDead ? 20 : 5); m++)
			{
				int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
				if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
			}
			if (isDead)
			{
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCHead"], 1f);
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCBody"], 1f);
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCLeg"], 1f);
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCLeg"], 1f);
			}
		}

        public override void PostNPCLoot() 
        {
            if ((float)Main.rand.NextDouble() < 0.1f) //10% chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width, npc.height, 285, 1, false, 0); //aglet
            }
        }
    }
}
