using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace TemplateMod.NPCs
{
	//The ExampleX Classes are not meant to be used as their primary function, they are merely hook listings.
    public class ExampleNPC : ModNPC
    {
        public ExampleNPC(ModBase modBase, NPC n) : base(modBase, n){ }

		//global ModNPC only
		public override List<int> EditSpawnPool(int x, int y, List<int> pool, Player player) { return pool; }
		public override void UpdateSpawnRate(Player player) { }

		public override void AI() { }
		public override bool PreAI() { return true; }
		public override void PostAI() { }
		public override bool CanSpawn(int x, int y, int type, Player spawnedOn) { return false; }
		public override void NPCLoot() { }
		public override bool PreNPCLoot() { return true; }
		public override void PostNPCLoot() { }
		public override void SelectFrame(int frameSize) { }
		public override void HitEffect(int hitDirection, double damage, bool isDead) { }

		//called when this NPC damages a player.
		public override void DamagePlayer(Player p, int hitDir, ref int damage, ref bool crit, ref float critChance) { }
		public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit) { }

		//called when a player damages this NPC.
		public override void DamageNPC(Player p, int hitDir, ref int damage, ref bool crit, ref float critMult) { }
		public override void DealtNPC(Player p, int hitDir, int dmgDealt, bool crit) { }

		//called when an NPC attacks this friendly NPC, or when a friendly NPC is attacked by this NPC.
		public override void DamageFriendNPC(NPC npc, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult) { }
		public override void DealtFriendNPC(NPC npc, int hitDir, int dmgDealt, float knockback, bool crit) { }

		public override bool? CanHitPlayer(Player p) { return null; }
		public override bool? CanHitNPC(Player p) { return null; }
		public override bool? CanHitFriendNPC(NPC npc) { return null; }

		public override bool PreDraw(SpriteBatch sb) { return true; }
		public override void PostDraw(SpriteBatch sb) { }

		//townNPC stuff
		public override string SetName() { return "Townie"; }
		public override string SetChat() { return "I'm a town npc! Woo!"; }
		public override void SetupShop(Chest chest, ref int index) { } //called only for the town npc, used to set up the shop.
		public override bool ResetShop(Chest chest) { return true; } //called only for the town npc, used to prevent shop reset.
		public override void PostSetupShop(Chest chest, int lastIndex) { } //called globally, can be used to modify vanilla town npc shops.
		public override void SetChatButtons(ref string[] buttons) { }
		public override Action SetChatButtonAction(string[] buttons, int buttonIndex) { return null; }
		public override bool CanTownNPCSpawn() { return true; }
		public override string CheckConditions(int topX, int topY, int bottomX, int bottomY) { return null; } //used to set up custom room requirements. returns any problems it hits as a string.
    }
}
