using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace TemplateMod.NPCs
{
    public class ExampleTownNPC : ModNPC
    {
        public ExampleTownNPC(ModBase modBase, NPC n) : base(modBase, n){ }

		public override void HitEffect(int hitDirection, double damage, bool isDead)
		{
			for (int m = 0; m < (isDead ? 20 : 5); m++)
			{
				int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
				if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
			}
			if (isDead)
			{
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCHead"], 1f);
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCBody"], 1f);
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCLeg"], 1f);
				Gore.NewGore(npc.position, npc.velocity, Defs.gores["TemplateMod:ExampleMobNPCLeg"], 1f);
			}
		}

        public override string SetName()
        {
            int rand = Main.rand.Next(4);
            string name = "";
            switch(rand)
            {
                case 0: name = "Flurblargh"; break;
                case 1: name = "Blurgrad"; break;
                case 2: name = "Snurrdud"; break;
                default: name = "Deufdun"; break;
            }
            return name;
        }

        public override string SetChat() 
        {
            int rand = Main.rand.Next(4);
            string text = "";
            switch (rand)
            {
                case 0: text = "Gurd deals. Nouw wit 25 purcent less bitez!"; break;
                case 1: text = "Curn I haz a nibburl of yur brain?"; break;
                case 2: text = "Stiks un stones may brek mai bones, but oi'll neva feel poin!"; break;
                default: text = "Haf yu seen mur jaw? I murst've left et somewhure aroond hur..."; break;
            }
            string guidesName = NPC.AnyNPCs("Guide") ? Main.chrName[22] : null;
            if (guidesName != null && Main.rand.Next(4) == 0){ text = "Ai wurnce tried " + guidesName + "'s brain. Wus delishous. He looks at mur funneh nao though."; }
            return text;
        }

        public override void SetupShop(Chest chest, ref int index) 
        {
            chest.item[index].SetDefaults(1304); //zombie arm
            index++;
            chest.item[index].SetDefaults(1313); //book of skulls
            index++;
        }
        public override bool ResetShop(Chest chest) { return true; }

        public override void SetChatButtons(ref string[] buttons) //you can have up to 5 buttons (0-4)
		{
			buttons[0] = "Shop";
			buttons[1] = "Health";
		}
		public override Action SetChatButtonAction(string[] buttons, int buttonIndex)
		{
			if (buttonIndex == 0) //Shop buttons can return null if they are named 'Shop' and it will make it a shop automatically.
			{
				return null;
			}else
			if (buttonIndex == 1) //the 'Health' button
			{
				return () =>
				{
					Player player = Main.player[Main.myPlayer];
					if (player.statLifeMax2 >= 400)
					{
						Main.npcChatText = "Mmmm! Yous vury healdy.";
					}else
					if (player.statLifeMax2 >= 300)
					{
						Main.npcChatText = "Yous somewut healdy.";
					}else
					if (player.statLifeMax2 >= 200)
					{
						Main.npcChatText = "Yous kindu healdy.";
					}else
					{
						Main.npcChatText = "Yous not healdy. Yous need maor fud.";
					}
				};
			}
			return null; 
		}

		public override bool? CanHitFriendNPC(NPC npc) { return false; } //zombie doesn't get hurt by enemy npcs
    }
}
