using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace TemplateMod.Projectiles
{
    public class ExampleProjMagic : ModProjectile
    {
        public ExampleProjMagic(ModBase modBase, Projectile p) : base(modBase, p){ }

		public override void AI()
		{
			projectile.rotation = (float)System.Math.Atan2((double)projectile.velocity.Y, (double)projectile.velocity.X) + 1.57f;
			if(projectile.timeLeft % 2 == 0 && Main.netMode != 2)
			{
				int dustID = Dust.NewDust(projectile.position, projectile.width, projectile.height, 60, projectile.velocity.X * 0.2f, projectile.velocity.Y * 0.2f, 100, Color.White, 1.6f);
			}
		}

		public override bool OnTileCollide(ref Vector2 velocityChange) 
		{
			projectile.penetrate -= 1;
			if (projectile.penetrate <= 0) { return true; }
			if (Main.netMode != 2){	Main.PlaySound(0, (int)projectile.position.X, (int)projectile.position.Y, 1); }
			if (projectile.velocity.X != velocityChange.X) { projectile.velocity.X = -velocityChange.X; }
			if (projectile.velocity.Y != velocityChange.Y) { projectile.velocity.Y = -velocityChange.Y; }
			return false;
		}

        public override void PostKill() //spawns dust on collision and plays a sound.
        {
            if(Main.netMode != 2)//no need for sounds or dust serverside (0 == singleplayer, 1 == client, 2 == server)
            {
                Main.PlaySound(0, (int)projectile.position.X, (int)projectile.position.Y, 1);
                for (int m = 0; m < 10; m++) //projectile dust
                {
                    int dustID = Dust.NewDust(projectile.position, projectile.width, projectile.height, 60, 0, 0, 100, Color.White, 3.2f);
					Main.dust[dustID].velocity = new Vector2(Main.rand.Next(-10, 10) * 0.5f, Main.rand.Next(-10, 10) * 0.5f);
					Main.dust[dustID].noGravity = true;
                }
            }
        }

		public static Vector2 RotateVector(Vector2 origin, Vector2 vecToRot, float rot)
		{
			float newPosX = (float)(Math.Cos(rot) * (vecToRot.X - origin.X) - Math.Sin(rot) * (vecToRot.Y - origin.Y) + origin.X);
			float newPosY = (float)(Math.Sin(rot) * (vecToRot.X - origin.X) + Math.Cos(rot) * (vecToRot.Y - origin.Y) + origin.Y);
			return new Vector2(newPosX, newPosY);
		}
    }
}
