using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace TemplateMod.Projectiles
{
	//The ExampleX Classes are not meant to be used as their primary function, they are merely hook listings.
    public class ExampleProjectile : ModProjectile
    {
        public ExampleProjectile(ModBase modBase, Projectile p) : base(modBase, p){ }

		public override void AI() { }
		public override bool PreAI() { return true; }
		public override void PostAI() { }
		public override void Kill() { }
		public override bool PreKill() { return true; }
		public override void PostKill() { }
		public override bool OnTileCollide(ref Vector2 velocityChange) { return true; }

		//Called when a projectile not owned by any player (ie fired from an npc) damages a player.
		public override void DamagePlayer(Player p, int hitDir, ref int damage, ref bool crit, ref float critMult) { }
		public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit) { }

		//Called when a projectile owned by a player damages another player.
		public override void DamagePVP(Player p, int hitDir, ref int damage, ref bool crit, ref float critMult) { }
		public override void DealtPVP(Player p, int hitDir, int dmgDealt, bool crit) { }

		//Called when a projectile owned by a player damages an npc.
		public override void DamageNPC(NPC npc, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult) { }
		public override void DealtNPC(NPC npc, int hitDir, int dmgDealt, float knockback, bool crit) { }

		public override bool? CanHitPlayer(Player p) { return null; }
		public override bool? CanHitPVP(Player p) { return null; }
		public override bool? CanHitNPC(NPC npc) { return null; }

		public override bool PreDraw(SpriteBatch sb) { return true; }
		public override void PostDraw(SpriteBatch sb) { }
    }
}
