using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace TemplateMod.Tiles
{
	public class ExampleTileStatue : ModTile
	{
		public ExampleTileStatue(ModBase modBase) : base(modBase) { }

		public override void Update() { } // called every single frame.

		public override void PreDraw(SpriteBatch sb, bool solidTiles) { } // Called before all tiles draw - can be used to draw something under the tile
		public override void PostDraw(SpriteBatch sb, bool solidTiles) { } // Called after all tiles draw - can be used to draw something over the tile
		public override void ModifyLight(int x, int y, ref Color color) { } // modify the light this tile produces. If color is anything but Color.Black, it will light using the color.

		public override bool CanPlace(int x, int y) { return true; } //return true if the tile can be placed in this spot
		public override void PlaceTile(int x, int y) { } // Called on the moment of placement

		public override bool PreKill(int x, int y, bool fail, bool effectsOnly, bool noItem) { return true; }
		public override void Kill(int x, int y, bool fail, bool effectsOnly, bool noItem) { }
		public override void PostKill(int x, int y, bool fail, bool effectsOnly, bool noItem) { }

		public override bool TileFrame(int x, int y) { return false; } // Called when the tile frame is checked, return true to prevent default behavior.

		public override bool MouseOver(int x, int y, SpriteBatch sb) // Called when the mouse hovers over the tile, return true to confirm you did something.
		{
			API.main.MouseText("Example Tile Statue");
			return true;
		}
		public override bool RightClick(int x, int y) { return false; } // Called when the tile is right clicked, return true to confirm you did something.
		public override void HitWire(int x, int y, int wireType) { } // Called when activated by wire.
	}
}

